// Author: Damian Straszak
#include <string>
#include <vector>

using namespace std;

int ispower[1<<18],possible[1<<18];

int get_next_left(int old,int x,int oldsum)
{
	int a=old,b=oldsum-a;
	if (a%x==0) a+=x;
	else return -1;
	if (ispower[a]!=-1)
	{
		if (2*a>b) 
		{
			b+=a;
			a=0;
		}
	}
	return a;
}

int get_next_right(int old,int x,int oldsum)
{
	int a=old,b=oldsum-a;
	if (b%x==0) b+=x;
	else return -1;
	if (ispower[b]!=-1)
	{
		if (2*b>a) 
		{
			a+=b;
			b=0;
		}
	}
	return a;
}

int main()
{
	for(int i=0;i<(1<<18);i++) ispower[i]=-1;
	for(int i=0;i<18;i++) ispower[1<<i]=i;
    int te;
    scanf("%d",&te);
    while(te--)
    {
    	int n;
    	scanf("%d",&n);
    	vector<vector<int> > v(n+1);
    	v[0]=vector<int>(1,0);
    	vector<int> num(n);
    	for(int i=0;i<n;i++) scanf("%d",&num[i]);
    	int sum=0;
    	for(int i=0;i<n;i++) sum+=num[i];
    	if (ispower[sum]==-1) {puts("no");continue;}
    	sum=0;
    	for(int i=1;i<=n;i++)
    	{
    		int x=num[i-1];
    		vector<int> pos;
    		for(int j=0;j<v[i-1].size();j++)
    		{
    			int y=v[i-1][j];
    			int yn[2]={get_next_right(y,x,sum),get_next_left(y,x,sum)};
    			for(int k=0;k<2;k++)
    			{
	    			if (yn[k]>=0 && !possible[yn[k]])
	    			{
	    				possible[yn[k]]=1;
	    				pos.push_back(yn[k]);
	    			}
	    		}
    		}
    		v[i]=pos;
    		for(int j=0;j<pos.size();j++) possible[pos[j]]=0;
    		sum+=x;
    	}
    	int b=-1;
    	for(int i=0;i<v[n].size();i++) if (v[n][i]==0 || v[n][i]==sum) b=i;
    	if (b<0) {puts("no");continue;}
    	string s;
    	for(int i=n-1;i>=0;i--)
    	{
    		int akt=v[i+1][b];
    		sum-=num[i];
    		for(int j=0;j<v[i].size();j++)
			{
				if (get_next_left(v[i][j],num[i],sum)==akt) {b=j;s+="l";break;}
				if (get_next_right(v[i][j],num[i],sum)==akt) {b=j;s+="r";break;}
			}
    	}
    	for(int i=n-1;i>=0;i--) printf("%c",s[i]);
    	puts("");
    }

	return 0;
}


