#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <ctime>
#include <cassert>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second

template<typename T> T abs(T x) {if (x>=0) return x; return -x;}

const int maxn = 3000005;

const ll mod = 1000000009;

ll dp[8][maxn];

char s[3][maxn];
int sum[3][maxn];
int n;

ll pows[maxn];

inline ll bpow(ll x, ll n)
{
	return pows[n];
}

void calc(int ind, int a, int b)
{
	dp[ind][n] = 0;
	for (int i = n - 1; i >= 0; i--)
	{
		dp[ind][i] = 0;
		if (s[a][i] != '?' && s[b][i] != '?')
		{
			if (s[a][i] < s[b][i])
			{
				dp[ind][i] = bpow(26, sum[a][i + 1] + sum[b][i + 1]);
			}
			else if (s[a][i] == s[b][i])
				dp[ind][i] = dp[ind][i + 1];
			else
				dp[ind][i] = 0;
		}
		else if (s[a][i] == '?' && s[b][i] != '?')
		{
			dp[ind][i] = dp[ind][i + 1] + max(0, (s[b][i] - 'a')) * bpow(26, sum[a][i + 1] + sum[b][i + 1]);
			dp[ind][i] %= mod;
		}
		else if (s[a][i] != '?' && s[b][i] == '?')
		{
			dp[ind][i] = dp[ind][i + 1] + max(0, (25 - (s[a][i] - 'a'))) * bpow(26, sum[a][i + 1] + sum[b][i + 1]);
			dp[ind][i] %= mod;
		}
		else
		{
			dp[ind][i] = ((26LL * 25) / 2) * bpow(26, sum[a][i + 1] + sum[b][i + 1]);
			dp[ind][i] += 26LL * dp[ind][i + 1];
			dp[ind][i] %= mod;
		}
	}
}

ll m[28 * 28 * 28][6];

int main()
{
	//freopen("a.in", "r", stdin);

	pows[0] = 1;
	for (int i = 1; i < maxn; i++)
		pows[i] = (pows[i - 1] * 26) % mod;

	for (int i = 0; i < 28; i++)
	{
		for (int j = 0; j < 28; j++)
		{
			for (int k = 0; k < 28; k++)
			{
				int c[3] = { i, j, k };

				int msk = i * 28 * 28 + j * 28 + k;

				for (int x = 1; x <= ((i == 27) ? 26 : 1); x++)
				{
					if (i != 27)
						c[0] = i;
					else
						c[0] = x;

					for (int y = 1; y <= ((j == 27) ? 26 : 1); y++)
					{
						if (j != 27)
							c[1] = j;
						else
							c[1] = y;

						for (int z = 1; z <= ((k == 27) ? 26 : 1); z++)
						{
							if (k != 27)
								c[2] = k;
							else
								c[2] = z;

							// 0 - 111, 1 - 110 * s2, 2 - 011 * s0, 3 - 26 ^ (s0 * s1 * s2)
							if (c[0] < c[1] && c[1] == c[2])
							{
								m[msk][2]++;
							}
							else if (c[0] == c[1] && c[1] < c[2])
							{
								m[msk][1]++;
							}
							else if (c[0] < c[1] && c[1] < c[2])
								m[msk][3]++;
							else if (c[0] == c[1] && c[1] == c[2])
								m[msk][0]++;
						}
					}
				}
			}
		}
	}

	int t;
	scanf("%d\n", &t);
	while (t--)
	{
		gets(s[0]);
		gets(s[1]);
		gets(s[2]);

		int len[3] = { (int)strlen(s[0]), (int)strlen(s[1]), (int)strlen(s[2]) };
		n = max(len[0], max(len[1], len[2]));

		for (int j = 0; j < 3; j++)
			for (int i = len[j]; i < n; i++)
				s[j][i] = 'a' - 1;

		for (int j = 0; j < 3; j++)
		{
			sum[j][n] = 0;
			for (int i = n - 1; i >= 0; i--)
				sum[j][i] = sum[j][i + 1] + (s[j][i] == '?');
		}

		calc(1 + 2, 0, 1);
		calc(2 + 4, 1, 2);


		dp[7][n] = 0;
		for (int i = n - 1; i >= 0; i--)
		{
			int c[3] = { s[0][i] - 'a' + 1, s[1][i] - 'a' + 1, s[2][i] - 'a' + 1 };
			if (s[0][i] == '?')
				c[0] = 27;
			if (s[1][i] == '?')
				c[1] = 27;
			if (s[2][i] == '?')
				c[2] = 27;
			int msk = 28 * 28 * c[0] + 28 * c[1] + c[2];

			ll res = 0;
			res += m[msk][0] * dp[7][i + 1];
			res %= mod;
			res += ((m[msk][1] * dp[1 + 2][i + 1]) % mod) * pows[sum[2][i + 1]];
			res %= mod;
			res += ((m[msk][2] * dp[2 + 4][i + 1]) % mod) * pows[sum[0][i + 1]];
			res %= mod;
			res += (m[msk][3] * pows[sum[0][i + 1] + sum[1][i + 1] + sum[2][i + 1]]);
			res %= mod;
			dp[7][i] = res;
		}
		
		printf("%d\n", (int)dp[7][0]);
	}
	

	return 0;
}