#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e3+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

int szn = 4, szm = 3;
int a[12][12];
int dx[2] = {1, 0};
int dy[2] = {0, 1};
map <int, int> m;

bool ok(int x, int y) {
	return x >= 0 && y >= 0 && x < szn && y < szm;
}

void dfs(int x, int y, int num) {
	if(a[x][y] > 9) return;
	if(num >= 1000) return;
	//cout << x << " " << y << " " << num << endl;
	m[num] = 1;
	if(num || a[x][y]) dfs(x, y, 10 * num + a[x][y]);
	for(int i = 0; i < 2; i++) {
		int nx = x + dx[i];
		int ny = y + dy[i];
		if(ok(nx, ny)) {
			dfs(nx, ny, num);
			dfs(nx, ny, 10 * num + a[x][y]);
		}
	}
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	int cnt = 1;
	for(int i = 0; i < 3; i++)
		for(int j = 0; j < 3; j++) a[i][j] = cnt++;
	a[3][0] = 10;
	a[3][1] = 0;
	a[3][2] = 10;	

	dfs(0, 0, 0);

	int t;

	scanf("%d", &t);

	while(t--) {
		int n;

		cin >> n;

		for(int d = 0;; d++) {
			int x = n-d;
			if(m[x]) {
				cout << x << endl;
				break;
			}
			x = n+d;
			if(m[x]) {
				cout << x << endl;
				break;
			}
		}

	}

	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
