#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)2e5+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

int n, k;
pii a[maxn];

bool cmp(pii a, pii b) {
	return a.f-a.s > b.f-b.s || (a.f-a.s == b.f-b.s && a.s < b.s);
}

int calc(vector <pii> v) {
	sort(all(v));

	int ans = 0;
	do {

		int cur = inf;
		int pr = 0;
		for(int i = 0; i < sz(v); i++) {
			pr += v[i].s;
			cur = min(cur, v[i].f-pr);
		}
		ans = max(ans, cur);

	} while(next_permutation(all(v)));

	return ans;
}

void solve() {
	scanf("%d%d", &n, &k);
	for(int i = 0; i < n; i++) {
		scanf("%d%d", &a[i].f, &a[i].s);
	}

	if(k >= n) {
		printf("0\n");
		return;
	}

	sort(a, a + n, cmp);

	vector <pii> v;
	for(int i = 0; i <= k; i++) v.pb(a[i]);

	printf("%d\n", calc(v));
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	int t;

	scanf("%d", &t);

	while(t--) solve();

	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
