#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
#include <cassert>
#include <ctime>
#include <utility>
#include <queue>

using namespace std;

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define fname ""

typedef long long LL;
typedef pair<int,int> pii;

const int maxn = (int)20;
const int inf = (int)1e9;
const int mod = (int)1e9 + 7;
const double eps = 1e-9;

int a[4][3] = {1, 2, 3,
			   4, 5, 6,
			   7, 8, 9
			   -1, 0, -1};

int b[maxn], sz, d[maxn][maxn][maxn], can[2000], ans, cur, t, n, was[maxn][maxn][maxn];

int calc(int x, int y, int v) {
//    cerr << x << ' ' << y << ' ' << v << '\n';
	if (was[x][y][v])
		return d[x][y][v];
	was[x][y][v] = true;
	if (v == sz)
		return d[x][y][v] = true;
	if (x > 3 || y > 2)
		return false;
	if (a[x][y] == b[v])
		d[x][y][v] = calc(x, y, v + 1);
	else
		d[x][y][v] = max(calc(x + 1, y, v), calc(x, y + 1, v));
	return d[x][y][v];
}

void rev(int x) {
	for (int i = 0; i < 20; ++i)
		for (int j = 0; j < 20; ++j)
			for (int k = 0; k < 20; ++k)
				was[i][j][k] = d[i][j][k] = false;
	sz = 0;
	while (!sz || x) {
		b[sz++] = x % 10;
		x /= 10;
	}
	return;
}

int main() {
//	freopen(fname"in", "r", stdin);
//	freopen(fname"out", "w", stdout);

	for (int i = 0; i <= 999; ++i) {
		rev(i);
		reverse(b, b + sz);
		can[i] = calc(0, 0, 0);
	} 

	scanf("%d", &t);
	while (t--) {
		scanf("%d", &n);
		ans = n;
		while (ans > 0 && !can[ans])
			--ans;
		cur = n;
		while (!can[cur])
			++cur;
		if (abs(n - ans) > abs(n - cur))
			ans = cur;
		printf("%d\n", ans);
	}

	return 0;
}
