import java.util.Scanner;


public class Main {
	
	public static int right(int key) {
		switch (key) {
			case 1:
				return 2;
			case 2:
				return 3;
			case 4:
				return 5;
			case 5:
				return 6;
			case 7:
				return 8;
			case 8:
				return 9;
		}
		return -1;
	}
	
	public static int down(int key) {
		switch (key) {
			case 1:
				return 4;
			case 2:
				return 5;
			case 3:
				return 6;
			case 4:
				return 7;
			case 5:
				return 8;
			case 6:
				return 9;
			case 8:
				return 0;
		}
		return -1;
	}
	
	public static int cur_sum;
	public static int target;
	
	public static void bruteforce(int currentKey, int currentValue) {
		//System.out.println(currentKey+" "+currentValue);
		if (currentKey == -1) return;
		if (currentKey == 0 && currentValue == 0) return;
		int cur_diff = Math.abs(cur_sum - target);
		int this_diff = Math.abs(currentValue - target);
		//System.out.println(this_diff+" "+cur_diff);
		if (this_diff < cur_diff) {
			cur_sum = currentValue;
		}
		if (currentValue > target) {
			return;
		}
		bruteforce(currentKey, currentValue*10 + currentKey);
		bruteforce(right(currentKey), currentValue);
		bruteforce(down(currentKey), currentValue);
	}
	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int t = in.nextInt();
		for (int test = 0; test<t; ++test) {
			target = in.nextInt();
			cur_sum = 0;
			bruteforce(1, 0);
			System.out.println(cur_sum);
		}
	}
	
	/*public static int sum(int N) {
		long lN = (long)N;
		long result = (lN*(lN+1))/2L;
		return (int)result;
	}
	
	public static int check(int N, int count) {
		int M = (N-sum(count-1));
		//System.out.println(N + " " + count);
		if (M % count == 0) {
			return M/count;
		}
		return -1;
	}
	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int t = in.nextInt();
		for (int test = 0; test<t; ++test) {
			int N = in.nextInt();
			if (N==1) {
				System.out.println("IMPOSSIBLE");
				continue;
			}
			int count = 2;
			int cmax = ((int)Math.sqrt(N)) * 2;
			while (check(N, count) == -1 && count < cmax) {
				++count;
			}
			if (check(N, count) == -1) {
				System.out.println("IMPOSSIBLE");
				continue;
			}
			StringBuilder buf = new StringBuilder();
			buf.append(N).append(" = ");
			int start = check(N, count);
			buf.append(start);
			for (int i=1;i<count;++i) {
				buf.append(" + ").append(start+i);
			}
			System.out.println(buf);
		}
	}*/

}
