#include <iostream>

using namespace std;

bool g[1000];

void dfs(int v)
{
	if(v > 999)
		return;
	if(g[v])
		return;
	g[v] = true;
	if(v == 0)
	{
		for(int i = 1; i <= 9; i++)
			dfs(i);
	}
	else
	{
		int last_digit = v % 10;
		if(last_digit != 0)
			for(int i = last_digit; i <= 9; i++)
				dfs(10*v + i);
		if(last_digit % 3)
			dfs(10*v);
	}
}

void solve()
{
	int k;
	cin >> k;
	int ans = 0;
	for(int i = 1; i < 1000; i++)
	{
		//cerr << "lal " << i << endl;
		//cerr << abs(g[i] - k) << " and " << abs(ans - k) << endl;
		if(g[i] && (abs(i - k) < abs(ans - k)))
			ans = i;
		else if(g[i])
			break;
	}
	cout << ans << endl;
}

int main()
{
	dfs(0);
	int t;
	cin >> t;
	for(int i = 0; i < t; i++)
		solve();
	//cin >> t;
	return 0;
}