#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

int timerR = 0;

void solve();
void prec();

int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	prec();
	cin >> t;
	while(t--) {
		//++timerR;
	//cout << "Case #" << timerR << ": ";
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

vector <vector <int> > g;

void init() {
	g.clear();
	g.resize(10);

	for (int i = 0; i < 10; ++i) {
		g[i].push_back(i);
	}

	g[1].push_back(2);
	g[1].push_back(4);
	g[2].push_back(3);
	g[2].push_back(5);

	g[3].push_back(6);
	g[4].push_back(5);
	g[4].push_back(7);

	g[5].push_back(6);
	g[5].push_back(8);
	g[6].push_back(9);

	g[7].push_back(8);
	g[8].push_back(0);
	g[8].push_back(9);

}

int cur = 0;
vector <int> a;

void dfs(int v) {
	
	if (cur > 10000) {
		return;
	}

	cur = cur * 10 + v;
	a.push_back(cur);

	if (v == 0 && cur == 0) {
		return;	
	}

	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		dfs(to);
	}

	cur /= 10;

	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		if (to != v)
			dfs(to);
	}
}

void prec() {
	init();		
	dfs(1);
	sort(a.begin(), a.end());
	a.erase(unique(a.begin(), a.end()), a.end());
}

void solve() {
	int x;
	cin >> x;
	int res = 2000;
	int f;

	int i = 0;
	vector <int>::iterator it = lower_bound(a.begin(), a.end(), x);
	if (it != a.begin()) {
		--it;
	}

	for (; i < 4 && it != a.end(); ++i, ++it) {
		if (res > abs((*it) - x)) {
			res = abs((*it) - x);
			f = *it;
		}
	}
	cout << f << "\n";
}