#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <stack>

using namespace std;

int d[111111];

int solve(int l, int r)
{
	if (l > r) return 0;
	int res = r - l + 1;
	for(int i = l; i < r - 1; i++)
	{
		int cur = min(d[i], min(i - l + 1, r - i));
		if (cur > 0)
		{
			res = min(res, solve(i - cur + 1, i) + (r - l + 1) - cur * 2 + 1);
		}		
	}
	return res;
}

int main() {
	ios_base::sync_with_stdio(false);
	int tests;
	cin >> tests;
	for(int i = 0; i < tests; i++)
	{
		string s;
		cin >> s;
		int mid = -1, r = -1;
		int n = s.size();
		for(int i = 0; i < n - 1; i++)
		{
			if (i < r)
			{
				d[i] = d[i - (i - mid) * 2];
			} else {
				d[i] = 0;
			}
			while (i + d[i] + 1 < n && i - d[i] >= 0 && s[i + d[i] + 1] == s[i - d[i]])
				d[i]++;
			if (i + d[i] > r)
			{
				r = i + d[i];
				mid = i;
			}
			//cout << d[i] << " ";
		}
		//cout << endl;
		cout << solve(0, n - 1) << endl;
		
	}
    return 0;
}
