#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

const int MAXN = 1000100;
const int MOD = 1000000009;
char s[3][MAXN];
int lens[3];
li dp[MAXN][2][2];


void solve() {
	for (int i = 0; i < 3; i++)
		gets(s[i]);
	for (int i = 0; i < 3; i++)
		lens[i] = strlen(s[i]);
	int len = max(lens[0], max(lens[1], lens[2]));
	for (int i = 0; i < 3; i++) {
		for (int j = 0; j < len; j++)
			if (lens[i] <= j)
				s[i][j] = 'a' - 1;
	}
	for (int i = 0; i < len + 1; i++)
		dp[i][0][0] = dp[i][1][1] = dp[i][1][0] = dp[i][0][1] = 0;
	dp[0][0][0] = 1;
	dp[0][0][1] = dp[0][1][0] = dp[0][1][1] = 0;
	for (int i = 0; i < len; i++) {
		for (int letter = 'a' - 1; letter <= 'z'; letter++) {
			if (letter == 'a' - 1 && s[1][i] == '?')
				continue;
			if (s[1][i] == letter || s[1][i] == '?') {
				li res;
				
				// 0 0
				res = 0;
				if ((s[0][i] != '?' && s[0][i] != letter) || 
					(s[2][i] != '?' && s[2][i] != letter))
					res = 0;
				else
					res = dp[i][0][0];
				dp[i + 1][0][0] = (dp[i + 1][0][0] + res) % MOD;

				// 0 1
				if (s[0][i] != '?' && s[0][i] != letter)
					res = 0;
				else {
					if (s[2][i] == '?') {
						li r1 = (dp[i][0][1] * 26) % MOD;
						li r2 = (dp[i][0][0] * ('z' - letter)) % MOD;
						res = (r1 + r2) % MOD;
					} else {
						li r1 = dp[i][0][1];
						li r2 = 0;
						if (s[2][i] > letter)
							r2 = dp[i][0][0];
						res = (r1 + r2) % MOD;
					}
				}
				dp[i + 1][0][1] = (dp[i + 1][0][1] + res) % MOD;

				// 1 0
				if (s[2][i] != '?' && s[2][i] != letter)
					res = 0;
				else {
					if (s[0][i] == '?') {
						li r1 = (dp[i][1][0] * 26) % MOD;
						li r2 = (dp[i][0][0] * (letter - 'a')) % MOD;
						res = (r1 + r2) % MOD;
					} else {
						li r1 = dp[i][1][0];
						li r2 = 0;
						if (s[0][i] < letter)
							r2 = dp[i][0][0];
						res = (r1 + r2) % MOD;
					}
				}
				dp[i + 1][1][0] = (dp[i + 1][1][0] + res) % MOD;

				// 1 1
				if (s[0][i] == '?' && s[2][i] == '?') {
					li r1 = 0, r2 = 0, r3 = 0, r4 = 0;
					r1 = (dp[i][1][1] * 26 * 26) % MOD;
					r2 = (dp[i][1][0] * 26 * ('z' - letter)) % MOD;
					r3 = (dp[i][0][1] * 26 * (letter - 'a')) % MOD;
					r4 = (dp[i][0][0] * ('z' - letter) * (letter - 'a')) % MOD;
					res = (r1 + r2 + r3 + r4) % MOD;
				} else if (s[0][i] == '?' && s[2][i] != '?') {
					li r1 = 0, r2 = 0, r3 = 0, r4 = 0;
					r1 = (dp[i][1][1] * 26) % MOD;
					if (s[2][i] > letter)
						r2 = (dp[i][1][0] * 26) % MOD;
					r3 = (dp[i][0][1] * (letter - 'a')) % MOD;
					if (s[2][i] > letter)
						r4 = (dp[i][0][0] * (letter - 'a')) % MOD;
					res = (r1 + r2 + r3 + r4) % MOD;
				} else if (s[0][i] != '?' && s[2][i] == '?') {
					li r1 = 0, r2 = 0, r3 = 0, r4 = 0;
					r1 = (dp[i][1][1] * 26) % MOD;
					r2 = (dp[i][1][0] * ('z' - letter)) % MOD;
					if (s[0][i] < letter)
						r3 = (dp[i][0][1] * 26) % MOD;
					if (s[0][i] < letter)
						r4 = (dp[i][0][0] * ('z' - letter)) % MOD;
					res = (r1 + r2 + r3 + r4) % MOD;
				} else {
					li r1 = 0, r2 = 0, r3 = 0, r4 = 0;
					r1 = (dp[i][1][1]) % MOD;
					if (s[2][i] > letter)
						r2 = (dp[i][1][0]) % MOD;
					if (s[0][i] < letter)
						r3 = (dp[i][0][1]) % MOD;
					if (s[2][i] > letter && s[0][i] < letter)
						r4 = (dp[i][0][0]) % MOD;
					res = (r1 + r2 + r3 + r4) % MOD;
				}
				dp[i + 1][1][1] = (dp[i + 1][1][1] + res) % MOD;
			}
		}
	}
	printf("%lld\n", dp[len][1][1]);
	cerr << dp[len][1][1] << endl;
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n;
	scanf("%d\n", &n);
	for (int i = 0; i < n; i++)
		solve();
}