#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

const int maxn = 150005;
const int maxk = 12;
const int inf = 1e9;

int dp[maxn][maxk];

struct Elem
{
	int v, c;
};

bool operator < (Elem first, Elem second)
{
	if (first.v - first.c != second.v - second.c)
		return first.v - first.c < second.v - second.c;
	return first.c < second.c;
}

Elem a[maxn];

inline void upd(int & x, int y)
{
	x = min(x, y);
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int tests;
	scanf("%d", &tests);
	forn(test, tests)
	{
		int n, k;
		scanf("%d%d", &n, &k);
		int maxv = 0;
		forn(j, n)
		{
			scanf("%d%d", &a[j].v, &a[j].c);
			maxv = max(maxv, a[j].v);
		}
		sort(a, a + n);
		int start = 0;
		int finish = maxv;
		while(start < finish)
		{
			int X = (start + finish) / 2 + 1;
			forn(j, n + 1)
				forn(h, k + 2)
					dp[j][h] = inf;
			dp[0][0] = X;
			forn(i, n)
				fore(h, 0, k + 1) if (dp[i][h] != inf)
				{
					if (a[i].v - a[i].c >= dp[i][h])
						upd(dp[i + 1][h + 1], dp[i][h] + a[i].c);
					upd(dp[i + 1][h], dp[i][h]);
				}
			if (dp[n][k + 1] != inf)
				start = X;
			else finish = X - 1;
		}
		printf("%d\n", start);
	}
}