#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

const int N = 1010;
const int M = 500100;

struct Input {
	int n;
	vector <int> a[N];
	int m;
	pair<int, int> z[M];		
	
	bool read () {
		if (scanf ("%d", &n) != 1)
			return 0;
		forn(i, n - 1) {
			int u, v;
			scanf ("%d %d", &u, &v);
			u--, v--;
			a[u].pb(v);
			a[v].pb(u);		
		}
		scanf ("%d", &m);
		forn(i, m) {
			scanf ("%d %d", &z[i].fs, &z[i].sc);
			z[i].fs--;
			z[i].sc--; 
		}
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	int ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

const int inf = 1000000000;
const int K = 20;

struct Solution: Data {

	int tw[11][N];
	int h[N];
	int p[N];	
	vector <int> nm[N];
	int d[N][N];
	int e[K], ee[K][K];
	int c[15][1100];
	int help[K];
	int dp[K];
	
	inline int up (int v, int h) {
		forn(i, 11) {
			if (h & (1 << i)) {
				v = tw[i][v];
			}
		}	
		return v;
	}
	
	inline int get_lca (int u, int v) {
		if (h[u] > h[v])
			swap(u, v);
		v = up(v, h[v] - h[u]);
		if (u == v)
			return u;
		ford(i, 11) {
			if (tw[i][u] != tw[i][v]) {
				u = tw[i][u];
				v = tw[i][v];
			}	
		}
		return p[u];
	}
	
	void dfs (int v, int pr = -1, int h1 = 0) {
		h[v] = h1;
		p[v] = pr;
		forn(i, a[v].size()) {
			int to = a[v][i];
			if (to == pr)
				continue;
			dfs(to, v, h1 + 1);
		}
	}
	
	inline int get_num (int v, int to) {
		bool q = 0;
		forn(i, a[v].size()) {
			int to1 = a[v][i];
			if (to1 == p[v]) {
				q = true;
				continue;
			}
			if (to1 == to) {
				return i - q;
			}
		}
		return -1;
	}
	
	void calc (int v) {
		forn(i, a[v].size()) {
			int to = a[v][i];
			if (to == p[v]) 
				continue;
			calc(to);
		}
		int sz = 0;
		forn(i, a[v].size()) {
			if (a[v][i] == p[v])
				continue;
			help[sz++] = a[v][i]; 
		}
		memset(e, 0, sizeof(e));
		memset(ee, 0, sizeof(ee));
		forn(i, nm[v].size()) {
			int idx = nm[v][i];
			int u1 = z[idx].fs, u2 = z[idx].sc;
			int to2 = up(u2, h[u2] - h[v] - 1), num2 = get_num(v, to2);
			if (u1 == v) {
				umx(e[num2], d[to2][u2] + 1);
				continue;
			}
			int to1 = up(u1, h[u1] - h[v] - 1), num1 = get_num(v, to1);
			umx(ee[num1][num2], d[to1][u1] + d[to2][u2] + 1);
			umx(ee[num2][num1], ee[num1][num2]);
		}
		debug(nm[v]);
		debug(v);
		int kol = (int)a[v].size() - (v != 0);
		forn(i, kol + 1) {
			forn(j, (1 << i)) {
				c[i][j] = 0;
			}
		}
		forn(i, kol) {
			forn(j, (1 << i)) {
				umx(c[i + 1][j], c[i][j] + d[help[i]][help[i]]);
				umx(c[i + 1][j | (1 << i)], c[i][j] + e[i]);
				forn(k, i) {
					if (j & (1 << k))
						continue;
					umx(c[i + 1][j | (1 << i) | (1 << k)], c[i][j] + ee[i][k] - d[help[k]][help[k]]);
				}
			}
		}
		memset(dp, 0, sizeof(dp));
		forn(i, (1 << kol)) {
			forn(j, kol) {
				umx(d[v][v], c[kol][i]);
				if (i & (1 << j))
					continue;
				umx(dp[j], c[kol][i]);		
			}
		}	
		
		forn(i, n) {
			if (h[i] <= h[v])
				continue;
			int to = up(i, h[i] - h[v] - 1);
			if (p[to] != v)
				continue;
			int num = get_num(v, to);
			d[v][i] = umx(d[v][i], dp[num] - d[to][to] + d[to][i]);	
		}
	}
	
	void solve () {
		dfs(0, -1, 0);
		p[0] = 0;
		forn(i, n) {
			tw[0][i] = p[i];
		}
		for (int i = 1; i < 11; ++i) {
			forn(j, n) {
				tw[i][j] = tw[i - 1][tw[i - 1][j]];
			}
		}
		forn(i, m) {
			if (h[z[i].fs] > h[z[i].sc]) {
				swap(z[i].fs, z[i].sc);
			}
			int j = get_lca(z[i].fs, z[i].sc);
			nm[j].pb(i);
		}
		forn(i, n) {
			debug(nm[i]);
		}
		forn(i, n + 1)
			forn(j, n + 1)
				d[i][j] = 0;
		calc(0);	
		forn(i, n + 1) {
			umx(ans, d[0][i]);
		}
	}
	
	void clear () {
		//*this = Soluti
		forn(i, n) {
			nm[i] = vector<int>();
			a[i] = vector<int>();
		}
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
#endif
	int t;
	cin >> t;
	forn (i, t) {
		sol.read();
		sol.solve();
		sol.write();
		sol.clear();
	}
	return 0;
}
