#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}


const int N = 1e6;
const int K = 3;

struct Input {
	char s[K][N + 1];
	
	bool read () {
		forn (i, K) {
			gets(s[i]);
		}
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	int ans;
	
	void write () {
		printf("%d\n", ans);	
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

const int C = 27;
const int mod = 1e9 + 9;
const int M = K - 1;
namespace Precalc {

static ll cnt[C + 1][C + 1][C + 1][1 << M][1 << M];
int idx[K], mask, mask2, val[K];

inline int sgn (int x) {
	if (x == 0) {
		return 0;
	}
	return x > 0 ? 1 : -1;
}

void go (int x) {
	if (x == K) {
		int e[2] = {sgn(val[1] - val[0]), sgn(val[2] - val[1])};
		int f[2] = {(mask & 1), (mask >> 1)};
		int g[2] = {(mask2 & 1), (mask2 >> 1)};
		
		forn (i, M) {
			if (e[i] < 0 && f[i] == 0) {
				return;
			}
			if (g[i] != (f[i] | (e[i] > 0))) {
				return;
			}
		}
		++cnt[idx[0]][idx[1]][idx[2]][mask][mask2];
		return;
	}
	
	if (idx[x] == C) {
		for (int i = 1; i < C; ++i) {
			val[x] = i;
			go(x + 1);
		}
	}
	else {
		val[x] = idx[x];
		go(x + 1);
	}
}

static void precalc () {
	memset(cnt, 0, sizeof cnt);
	for (int i = 0; i <= C; ++i) {
		for (int j = 0; j <= C; ++j) {
			for (int k = 0; k <= C; ++k) {	
				idx[0] = i;
				idx[1] = j;
				idx[2] = k;
				for (int mask = 0; mask < (1 << M); ++mask) {
					for (int mask2 = 0; mask2 < (1 << M); ++mask2) {
						Precalc::mask = mask;
						Precalc::mask2 = mask2;
						go(0);
					}
				}
			}
		}
	}
}
}

	
struct Solution: Data {
	int dp[2][1 << M];
	
	void solve () {
		int len[K];
		int n = 0;
		forn (i, K) {
			len[i] = strlen(s[i]);
			n = max(n, len[i]);
		}
//		debug(len, len + K);
		forn (i, K)  {
			for (int j = len[i]; j < n; ++j) {
				s[i][j] = 0;
			}
		}

		forn (i, K) {
			forn (j, len[i]) {
				if (s[i][j] == '?') {
					s[i][j] = C;
				}
				else {
					s[i][j] -= 'a';
					++s[i][j];
				}
			}
		}
		memset(dp[n & 1], 0, sizeof dp[n & 1]);
		dp[n & 1][3] = 1;
		using Precalc::cnt;
		
		for (int i = n - 1; i >= 0; --i) {
			for (int mask = 0; mask < (1 << M); ++mask) {
				int & r = dp[i & 1][mask];
				r = 0;
				for (int mask2 = 0; mask2 < (1 << M); ++mask2) {
					r += (cnt[(int)s[0][i]][(int)s[1][i]][(int)s[2][i]][mask][mask2] * dp[(i + 1) & 1][mask2]) % mod;
					if (r >= mod) {
						r -= mod;
					}
				}
			}
		}
		ans = dp[0][0];
	}
	
	void clear () {
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("f.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
#endif
	Precalc::precalc();
	int t;
	cin >> t;
	scanf("\n");
	forn (i, t) {
		sol.read();
		sol.solve();
		sol.write();
		sol.clear();
	}
	return 0;
}
