#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int N = 1111;
typedef pair< pair< int, pair<int, int> >, pair< int, char > > megapair;
vector< megapair > states[N];
int n, x, t, sum;

bool cmp_args(const megapair& a, const megapair& b) {
	return (a.fs == b.fs);
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%d", &t);
	for (int it = 0; it < t; ++it) {
		scanf("%d", &n), sum = 0;
		states[0].clear();
		states[0].pb(mp(mp(0, mp(0, 0)), mp(-1, -1)));
		for (int i = 1; i <= n; ++i) {
			scanf("%d", &x), sum += x;
			states[i].clear();
			for (int j = 0; j < sz(states[i - 1]); ++j) {
				int mx = states[i - 1][j].fs.fs, l = states[i - 1][j].fs.sc.fs, r = states[i - 1][j].fs.sc.sc;
				if (l == 0) {
					if (x > mx)
						states[i].pb(mp(mp(x, mp(0, mx + r)), mp(j, 'l')));
					else if (x == mx)
						states[i].pb(mp(mp(x + mx, mp(0, r)), mp(j, 'l')));
					else
						states[i].pb(mp(mp(mx, mp(x, r)), mp(j, 'l')));
				} else if ((l & (x - 1)) == 0) {
					if (l + x == mx)
						states[i].pb(mp(mp(l + x + mx, mp(0, r)), mp(j, 'l')));
					else
						states[i].pb(mp(mp(mx, mp(l + x, r)), mp(j, 'l')));
				}
				if (r == 0) {
					if (x > mx)
						states[i].pb(mp(mp(x, mp(mx + l, 0)), mp(j, 'r')));
					else if (x == mx)
						states[i].pb(mp(mp(x + mx, mp(l, 0)), mp(j, 'r')));
					else
						states[i].pb(mp(mp(mx, mp(l, x)), mp(j, 'r')));
				} else if ((r & (x - 1)) == 0) {
					if (r + x == mx)
						states[i].pb(mp(mp(mx + r + x, mp(l, 0)), mp(j, 'r')));
					else
						states[i].pb(mp(mp(mx, mp(l, r + x)), mp(j, 'r')));
				}
			}
			sort(states[i].begin(), states[i].end());
			states[i].resize(unique(states[i].begin(), states[i].end(), cmp_args) - states[i].begin());
		}
		if (states[n].empty() || (states[n].back().fs.fs != sum))
			printf("no\n");
		else {
			int j = sz(states[n]) - 1;
			string res;
			for (int i = n; i > 0; --i) {
				res.pb(states[i][j].sc.sc);
				j = states[i][j].sc.fs;
			}
			reverse(res.begin(), res.end());
			printf("%s\n", res.data());
		}
	}
	return 0;
}