#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int maxk = 500;

int ans[maxk];
bool can[maxk];

bool f[10][10];


bool isCan(int x)
{
	stringstream ss;
	ss << x;
	string s = ss.str();

	int n = s.length();
	int cur = 1;
	for (int i = 0; i < n; ++i)
	{
		if (!f[cur][s[i] - '0'])
			return false;
		cur = s[i] - '0';
	}
	return true;
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 


	memset(f[1], true, sizeof(f[1]));
	
	memset(f[2], true, sizeof(f[2]));
	f[2][1] = f[2][4] = f[2][7] = false;

	f[3][3] = f[3][6] = f[3][9] = true;

	memset(f[4], true, sizeof(f[4]));
	f[4][1] = f[4][2] = f[4][3] = false;

	f[5][5] = f[5][6] = f[5][8] = f[5][9] = f[5][0] = true;

	f[6][6] = f[6][9] = true;

	f[7][8] = f[7][9] = f[7][0] = f[7][7] = true;

	f[8][8] = f[8][9] = f[8][0] = true;

	f[9][9] = true;

	f[0][0] = true;


	for (int i = 0; i < maxk; ++i)
		can[i] = isCan(i);

	for (int i = 0; i < maxk; ++i)
	{
		int best = -1;
		for (int j = 0; j < maxk; ++j)
		{
			if (!can[j])
				continue;
			if (best == -1 || abs(best - i) > abs(j - i))
				best = j;
		}
		ans[i] = best;
	}

	int T;
	scanf("%d", &T);
	for (int t = 0; t < T; ++t)
	{
		int k;
		scanf("%d", &k);
		printf("%d\n", ans[k]);
	}

	return 0;
}