#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MAXN = 606;

vector< int > allDays;
int used[MAXN][MAXN];
int ans[MAXN][MAXN];
int ITER;
int a[MAXN], b[MAXN], d[MAXN];
int n;

void
unzip(int *x, int n, const vector< int > &vals)
{
	for (int i = 0; i < n; ++i) {
		x[i] = lower_bound(vals.begin(), vals.end(), x[i]) - vals.begin();
	}
}

int
dyn(int l, int r)
{
	if (used[l][r] == ITER) {
		return ans[l][r];
	}
	used[l][r] = ITER;
	int &res = ans[l][r];
	res = 0;
	if (l <= r) {
		int id = -1;
		for (int i = 0; i < n; ++i) {
			if (a[i] >= l && b[i] <= r && (id == -1 || d[i] > d[id])) {
				id = i;
			}
		}
		if (id != -1) {
			res = d[id];
			int curVal = n * 20000;
			for (int i = a[id]; i <= b[id]; ++i) {
				curVal = min(curVal, dyn(l, i - 1) + dyn(i + 1, r));
			}
			res += curVal;
		}
	}
	return res;
}

void
process()
{
	scanf("%d", &n);
	allDays.clear();
	for (int i = 0; i < n; ++i) {
		scanf("%d%d%d", &a[i], &b[i], &d[i]);
		allDays.push_back(a[i]);
		allDays.push_back(b[i]);
	}
	ITER++;
	sort(allDays.begin(), allDays.end());
	allDays.resize(unique(allDays.begin(), allDays.end()) - allDays.begin());
	unzip(a, n, allDays);
	unzip(b, n, allDays);
	printf("%d\n", dyn(0, allDays.size() - 1));
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 

	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		process();
	}

	return 0;
}