#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <stack>
#include <cassert>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef pair<int, pair<int, int> > iii;
typedef pair<ll, ll> pl;

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

	int tests;
	cin >> tests;
	for (int q = 0; q < tests; q++)
	{
		ll n;
		cin >> n;
		bool found = 0;
		for (ll k = 1; k * k <= 2 * n; k++)
		{
			ll a = ((2 * n - k * (k + 1)) / (2 * (k + 1)));
			if (a < 1)
				continue;
			if (a * (k + 1) + (k * (k + 1)) / 2 == n)
			{
				found = 1;
				cout << n << " = ";
				for (ll i = a; i <= (a + k); i++)
				{
					cout << i;
					if (i != a + k)
						cout << " + ";
				}
				cout << "\n";
				break;
			}

			a = ((2 * n - k * (k + 1)) / (2 * (k + 1))) + 1;
			if (a < 1)
				continue;
			if (a * (k + 1) + (k * (k + 1)) / 2 == n)
			{
				found = 1;
				cout << n << " = ";
				for (ll i = a; i <= (a + k); i++)
				{
					cout << i;
					if (i != a + k)
						cout << " + ";
				}
				cout << "\n";
				break;
			}

			a = ((2 * n - k * (k + 1)) / (2 * (k + 1))) - 1;
			if (a < 1)
				continue;
			if (a * (k + 1) + (k * (k + 1)) / 2 == n)
			{
				found = 1;
				cout << n << " = ";
				for (ll i = a; i <= (a + k); i++)
				{
					cout << i;
					if (i != a + k)
						cout << " + ";
				}
				cout << "\n";
				break;
			}
		}
		if (!found)
		{
			cout << "IMPOSSIBLE\n";
		}
	}

    return 0;
}