#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
#include <bitset>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 2000*100 + 10;
const dbl eps = 1e-7;
const int mod = 1e9 + 7;

bool used[1000];
int matr[10][10];

void dfs(int cur, int x, int y) {
	if (x == -1 && y == -1) {
		used[cur] = true;
		return;
	}
	if (cur > 200 || (x == -1 && y == -1)) return;
	used[cur] = true;
	for (int i = x; i < 3; i++) {
		for (int j = y; j < 3; j++) {
			dfs(cur * 10 + matr[i][j], i, j);
		}
	}

	if (x <= 2 && y <= 1) {
		dfs(cur * 10, -1, -1);
	}
}

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	/*int t;
	scanf("%d", &t);
	while (t--) {
		int n;
		scanf("%d", &n);
		set <pair <int, pair <int, int> > > aliens;
		for (int i = 0; i < n; i++) {
			int a, b, d;
			scanf("%d%d%d", &a, &b, &d);
			aliens.insert(mp(b, mp(a, d)));
		}
		int ans = 0;
		while (!aliens.empty()) {
			pair <int, pair <int, int> > alien = *aliens.begin();
			vector <pair <int, pair <int, int> > > killed;
			killed.pb(alien);
			int mx = -1;
			for (set <pair <int, pair <int, int> > >::iterator it = aliens.begin(); it != aliens.end(); it++) {
				if (it->Y.X <= alien.X) {
					mx = max(mx, it->Y.Y);
					killed.pb(*it);
				}
			}
			for (int i = 0; i < sz(killed); i++)
				aliens.erase(killed[i]);
			ans += mx;
		}
		printf("%d\n", ans);
	}*/

	int c = 1;
	for (int i = 0; i < 3; i++)
		for (int j = 0; j < 3; j++) {
			matr[i][j] = c;
			c++;
		}

	used[0] = true;
	for (int i = 1; i <= 9; i++) {
		if (i == 1) dfs(i, 0, 0);
		if (i == 2) dfs(i, 0, 1);
		if (i == 3) dfs(i, 0, 2);
		if (i == 4) dfs(i, 1, 0);
		if (i == 5) dfs(i, 1, 1);
		if (i == 6) dfs(i, 1, 2);
		if (i == 7) dfs(i, 2, 0);
		if (i == 8) dfs(i, 2, 1);
		if (i == 9) dfs(i, 2, 2);

	}

	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; i++) {
		int k, minval = INT_MAX, ans;
		scanf("%d", &k);
		for (int j = 0; j < 2 * k; j++) {
			if (used[j] && abs(k - j) < minval) {
				minval = abs(k - j);
				ans = j;
			}
		}
		printf("%d\n", ans);
	}

	/*for (int k = 1; k <= 200; k++) {
		int minval = INT_MAX, ans;
		for (int j = 0; j < 2 * k; j++) {
			if (used[j] && abs(k - j) < minval) {
				minval = abs(k - j);
				ans = j;
			}
		}

		printf("%d\n", ans);
	}*/
	return 0;
}