#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <assert.h>
using namespace std;

#define EPS 1E-7
const long long MOD = 1000000007;
#define mp make_pair

long long sum(long long a, long long b){
	a--;
	return (1+b)*(b)/2 - (1+a)*a/2;
}

int main(){
	freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
	int t;
	cin>>t;
	vector<long long>sums(100001);
	sums[1]=1;
	for(int i=2; i<100001; ++i){
		sums[i]=sums[i-1]+i;
	}
	for(int T=0;T<t;++T){
		long long N;
		cin>>N;
			

		if(N==1){
			puts("IMPOSSIBLE");
			continue;
		}
		if(N%2){
			cout << N << " " << "=" << " " << N/2 << " + " << N/2 + 1<<endl;
			continue;
		}

		pair<long long, long long>ans(-1,-1);
		bool done=false;
		for(long long i = 2; i < (long long)(1+sqrt(1.+2*N))+1; ++i){
			if(i%2){
				if(N%i == 0 && N/i - (i-1)/2 >= 1){
					cout << N << " " << "= ";
					long long crr = N/i - (i-1)/2;
					for(int j=0; j<i; ++j){
						if(j!=i-1){
							printf("%d + ", crr);
							crr++;
						}
						else{
							printf("%d", crr);
						}
					}
					cout<<endl;

					done=true;
					break;
				}
			}
			else{
				if((2*N)%i == 0 && (2*N)/i % 2 == 1 && ((2*N)/i - i + 1)/2 >= 1){
					cout << N << " " << "= ";
					long long crr = ((2*N)/i - i + 1)/2;
					for(int j=0; j<i; ++j){
						if(j!=i-1){
							printf("%d + ", crr);
							crr++;
						}
						else{
							printf("%d", crr);
						}
					}
					cout<<endl;
					done=true;
					break;
				}
			}
		}
		if(!done){
			puts("IMPOSSIBLE");
		}
				
	}


	return 0;
}