
#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

string a, b, c;
int mem[1000100][2][2];

int mod = 1000000009;

char mn(char c, char x) {
    if (c == 0) return 0;
    if (c != '?') return c;
    return 'a';
    //return max('a', x);
}

char mx(char c) {
    if (c == 0) return 0;
    if (c != '?') return c;
    return 'z';
}

int cnt(int at, bool p1, bool p2) {
    if (at >= size(a) && at >= size(b) && at >= size(c))
        return !p1 && !p2 ? 1 : 0;

    if (mem[at][p1][p2] != -1)
        return mem[at][p1][p2];

    //printf("%d %d %d\n", at, p1 ? 1 : 0, p2 ? 1 : 0);

    char ac1 = at < size(a) ? a[at] : 0;
    char ac2 = at < size(b) ? b[at] : 0;
    char ac3 = at < size(c) ? c[at] : 0;

    int res = 0;
    for (char c1 = mn(ac1, 0); c1 <= mx(ac1); c1++) {
        //printf("a = %c\n", c1);
        for (char c2 = mn(ac2, c1); c2 <= mx(ac2); c2++) {
            if (c2 < c1 && p1) continue;
            //printf("b = %c\n", c2);
            for (char c3 = mn(ac3, c2); c3 <= mx(ac3); c3++) {
                if (c3 < c2 && p2) continue;
                //printf("c = %c\n", c3);
                //printf("%d %c %c %c\n", at, c1, c2, c3);
                res += cnt(at + 1, p1 && c1 == c2, p2 && c2 == c3);
                if (res >= mod) {
                    res -= mod;
                }
            }
        }
    }

    return mem[at][p1][p2] = res;
}

int main() {

    int ts;
    scanf("%d\n", &ts);

    for (int t = 0; t < ts; t++) {
        getline(cin, a);
        getline(cin, b);
        getline(cin, c);
        memset(mem, -1, sizeof(mem));
        printf("%d\n", cnt(0, true, true));
    }

    return 0;
}
