#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

const int N = 1000 + 5;
const int M = (1 << 13) + 5;

int n, u[N][M], T, a[N], sum[N];
pair<char, pt> p[N][M];

bool read() {
	if (scanf("%d", &n) != 1)
		return false;
	
	forn(i, n) {
		scanf("%d", &a[i]);
		sum[i + 1] = a[i] + sum[i];
	}

	T++;
	
	return true;
}

void solve() {
	queue <pt> q;
	q.push(mp(1, a[0]));

	while (!q.empty()) {
		pt t = q.front(); q.pop();

		int pos = t.ft, left = t.sc;
		assert(left != 0);

		if (pos == n)
			continue;

		int right = sum[pos] - left;

		int l = 1;
		int sl = 1;
		while (!(l & left))
			l <<= 1;

		while ((sl << 1) <= left)
			sl <<= 1;

		int r = 1;
		if (right) {
			while (!(r & right))
				r <<= 1;
		} else {
			r = 0;
		}

		if (a[pos] <= l) {
			int npos = pos + 1;
			int nleft = left + a[pos];

			if (u[npos][nleft] < T) {
				u[npos][nleft] = T;
				p[npos][nleft] = mp('l', mp(pos, left));
				q.push(mp(npos, nleft));
			}
		}

		if (a[pos] <= r || right == 0) {
			int npos = pos + 1;
			int nleft = left;

			right += a[pos];

			if (right >= sl)
				nleft += right;

			if (u[npos][nleft] < T) {
				u[npos][nleft] = T;
				p[npos][nleft] = mp('r', mp(pos, left));
				q.push(mp(npos, nleft));
			}
		}

	}

	int fin = sum[n];
	if ((fin & (fin - 1)) || u[n][fin] < T) {
		puts("no");
		return;
	}

	string res;

	int pos = n;
	int l = fin;

	while (pos != 1) {
		res = (p[pos][l].ft) + res;
		pt q = p[pos][l].sc;
		pos = q.ft;
		l = q.sc;
	}

	printf("l%s\n", res.c_str());
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	int t;
	scanf("%d", &t);

	while (read())
		solve();

	return 0;
}