#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

const int N = 200 * 1000 + 5;

int n;
pair <int, char> bl[N];
int cnt[2];

bool read() {
	forn(i, 2)
		cnt[i] = 0;
	if (scanf("%d", &n) != 1)
		return false;
	forn(i, n) {
		char buf[2];
		scanf("%d %s", &bl[i].ft, buf);
		bl[i].sc = buf[0];
		cnt[buf[0] == 'W'] += bl[i].ft;
	}
	return true;
}

int gcd(int a, int b) {
	return b == 0 ? a : gcd(b, a % b);
}

void solve() {
	if (cnt[0] == 0 || cnt[1] == 0) {
		printf("%d\n", max(cnt[0], cnt[1]));
		return;
	}

	int b = cnt[0];
	int w = cnt[1];

	int g = gcd(b, w);
	b /= g;
	w /= g;

	li c[2], r[2];

	r[0] = b;
	r[1] = w;

	forn(t, 2)
		c[t] = 0;

	int res = 0;

	forn(i, n) {
		int t = (bl[i].sc == 'W');
		li need = c[!t] * r[t];
		li cur = need / r[!t] - c[t];

		if (need % r[!t] != 0 || c[!t] == 0 || cur > bl[i].ft || cur < 0) {
			c[t] += bl[i].ft;
			continue;
		}

		res++;

		forn(i, 2)
			c[i] = 0;

		c[t] += bl[i].ft - cur;
	}

	printf("%d\n", res);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	int t;
	scanf("%d", &t);

	while (read())
		solve();

	return 0;
}