#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

int n, k;
const int N = 150095;
pt a[N];

bool read() {
	if (scanf("%d%d", &n, &k) != 2)
		return false;

	forn (i, n)
		scanf("%d%d", &a[i].sc, &a[i].ft);

	return true;
}

int dp[N][10];

void solve() {

	sort(a, a + n);

	forn (i, n)
		forn (j, k + 1)
			dp[i][j] = -INF;

	forn (i, k + 1)
		dp[n][i] = 0;

	for (int i = n - 1; i >= 0; --i)
	{
		forn (j, k)
			dp[i][j] = max(dp[i + 1][j], min(a[i].sc - a[i].ft, dp[i + 1][j + 1] - a[i].ft));
		dp[i][k] = max(dp[i + 1][k], a[i].sc - a[i].ft);
	}
	cout << dp[0][0] << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	int t;
	scanf("%d", &t);

	while (read())
		solve();

	return 0;
}