#include<iostream>
using namespace std;

typedef long long ll;

struct piece {
	int num; 
	char f;
};
struct fract {
	int b; 
	int w;
};

int gcd(int a, int b)
{
	if (a < b) swap(a,b);
	while(b)
	{
		a %= b;
		if (a < b) swap (a,b);
	}
	return a;
}

piece arr[100000];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int T;
	cin >> T;
	for (int k = 0; k < T; ++k) {
		int n;
		cin >> n;
		int W = 0;
		int B = 0;
		for(int j=0; j < n; j++)
		{
			cin >> arr[j].num;
			cin >> arr[j].f;
			if(arr[j].f == 'B')  B += arr[j].num;
			if(arr[j].f == 'W')  W += arr[j].num;
		}
		fract ratio;
		if(B != 0) ratio.b = B/gcd(B,W);
		if(W != 0) ratio.w = W/gcd(B,W);

		if(W == 0) {
			cout << B << endl;
			continue;
		}
		if(B == 0) {
			cout << W << endl;
			continue;
		}
		bool cut = true;
		ll yet = 0;
		ll b = 0;
		ll w = 0;
		int cnt = 0;
		for (int i = 0; i < n; ++i) {		
			if (arr[i].f == 'W') {
				yet = ratio.w * b;
				if (yet % ratio.b == 0) {
					ll need = yet / ratio.b;
					if ((w + arr[i].num >= need) && (need > 0)) {
						++cnt;
						b = 0;
						w = w + arr[i].num - need;
					}
					else {
						w += arr[i].num;
					}
				}
				else {
					w += arr[i].num;
				}
			}
			else {
				yet = ratio.b * w;
				if (yet % ratio.w == 0) {
					ll need = yet / ratio.w;
					if ((b + arr[i].num >= need) && (need > 0)) {
						++cnt;
						w = 0;
						b = b + arr[i].num - need;
					}
					else {
						b += arr[i].num;
					}
				}
				else {
					b += arr[i].num;
				}
			}
		}
		cout << cnt << endl;
	}
	return 0;
}