#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

using namespace std;

const int INF = 1e9;
const int N = 666;

int tt, f[N][N], n;
pair<pair<int, int>, int> a[N];


int main() {
	freopen("input.txt", "r", stdin);
	scanf("%d", &tt);
	while (tt--) {
		scanf("%d", &n);
		vector<pair<pair<int, int>, int>> v;
		for (int i = 0; i < n; i++) {
			scanf("%d%d%d", &a[i].first.first, &a[i].first.second, &a[i].second);
			v.push_back(make_pair(make_pair(a[i].first.first, i), 0));
			v.push_back(make_pair(make_pair(a[i].first.second, i), 1));
		}
		sort(v.begin(), v.end());
		int last = -1, cnt = 0;
		for (int i = 0; i < v.size(); i++) {
			if (v[i].first.first != last) {
				last = v[i].first.first;
				cnt++;	
			}
			if (v[i].second == 0) {
				a[v[i].first.second].first.first = cnt;
			} else {
				a[v[i].first.second].first.second = cnt;
			}
		}
		for (int l = cnt; l >= 1; l--) {
			for (int r = 1; r <= cnt; r++) {
				if (l >= r) {
					f[l][r] = 0;
					continue;
				}
				int cur = 0;
				for (int i = 0; i < n; i++) {
					if ((a[i].first.first >= l) && (a[i].first.second <= r)) {
						cur = max(cur, a[i].second);
					}
				}
				f[l][r] = INF;
				for (int i = l; i <= r; i++) f[l][r] = min(f[l][i - 1], f[i + 1][r]);
				f[l][r] += cur;
			}
		}
		printf("%d\n", f[1][cnt]);
	}
}