#!/bin/sh

gcc cptest.c -o cptest.exe
./cptest.exe < 01.hand > 001

g++ gen-random.cpp -O2 -std=c++0x -o generate.exe || exit 1
g++ gen-regular.cpp -O2 -std=c++0x -o generate1.exe || exit 1
g++ gen2.cpp -O2 -std=c++0x -o generate2.exe || exit 1
g++ ver.cpp -O2 -std=c++0x -o validate.exe || exit 1
g++ sol.cpp -O2 -std=c++0x -o solution.exe || exit 1

./generate2.exe <small-medium-overlapping.gen >002
./generate.exe >003
./generate2.exe <huge.gen >004
./generate1.exe >005


mkdir ../tests
for i in ???;do
echo Validating $i
./validate.exe <$i || exit 1
echo Generating $i.a
./solution.exe <$i >../tests/$i.a
mv $i ../tests/$i
done

rm *.exe
