#include <stdlib.h>
#include <algorithm>
#include "ver.h"
#include <cstdio>
#include <cstring>

const int maxn = 1e6;

char s[3][(1<<20)+3];

int main() 
{
	oi::Scanner in(stdin);
	int Z = in.readInt(1, 1e9);
	in.readEoln();
	while (Z--) 
	{
		for(int k=0;k<3;k++)
		{
			int n=in.readString(s[k],1<<20);
			if (n<1 || n>maxn) 
				in.error("string length out of range");
			for(int i=0;i<n;i++)
			{
				if (!(s[k][i]=='?' || ('a'<=s[k][i] && s[k][i]<='z'))) 
					in.error("wrong letter, not in {a,b,...,z,?}");
			}
        	in.readEoln();
		}
		int i;
		for (i=0; s[0][i]; i++)
		    if (s[0][i]=='?')
		        s[0][i] = 'a';
		for (i=0; s[2][i]; i++)
		    if (s[2][i]=='?')
		        s[2][i] = 'z';
		for (i=0; s[0][i] && s[1][i] && (s[0][i]==s[1][i] || s[1][i]=='?'); i++);
		if (s[0][i] < s[1][i])
		    for (; i>=0; i--)
		        if (s[1][i]=='?')
		            s[1][i] = s[0][i];
		for (; i>=0 && (s[0][i]==s[1][i] || s[0][i]=='z'); i--)
		    if (s[1][i]=='?')
		        s[1][i] = s[0][i];
		for (; i>=0 && s[0][i]==s[1][i]; i--);
		if (i>=0)
		    s[1][i] = s[0][i]+1;
		for (; i>=0; i--)
		    if (s[1][i]=='?')
		        s[1][i] = s[0][i];
		for (i=0; s[1][i]; i++)
		    if (s[1][i]=='?')
		        s[1][i] = 'a';
		if (strcmp(s[0],s[1]) >= 0 || strcmp(s[1],s[2]) >= 0)
		    in.error("the words cannot be ordered");
  	}
	in.readEof();
	puts("OK");
	return 0;
}
