#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
const int INF = 1e9;

const double PI = 3.1415926535897932384626433832795;

vector<pii> vig;
bool cmp(pii a,pii b){
	if(a.X == b.X)
		return a.Y<b.Y;
	return a.X>b.X;
}

int brute(vector<pii> vv,int k){
	sort(ALL(vv));
	int best = 0;
	do{
		vector<pii> temp;
		for(int i = 0;i <= k;i++){
			temp.pb(vv[i]);
		}
		int will = INF;
		for(int i = 0;i <= k;i++){
			int pr = temp[i].Y;
			int our = temp[i].X;
			will = min(our,will);
			for(int j = i+1;j <= k;j++){
				temp[j].X-=pr;
			}
		}
		best = max(best,will);
	}while(next_permutation(ALL(vv)));

	return best;
}
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int t;
	cin >> t;
	while(t--){
		int n,k;
		scanf("%d%d",&n,&k);
		vig.clear();
		for(int i = 0;i < n;i++){
			int a,b;
			scanf("%d%d",&a,&b);
			vig.pb(mp(a-b,b));
		}
		if(k>=n){
			cout << 0 << endl;
			continue;

		}
		sort(ALL(vig),cmp);
		vector<pii> check;
		for(int i = 0;i < min(n,k+1);i++){
			check.pb(vig[i]);
		}
		int ans = brute(check,min(n,k));
		//int ans = INF;
		//while(k>=0){
		//	sort(ALL(vig),cmp);
		//	int cur = vig[k].X;
		//	ans = min(ans,cur);
		//	int ont = vig[k].Y;
		//	for(int i = 0;i < n;i++){
		//		vig[i].X-=ont;
		//	}
		//	vig[k].X = 0;
		//	vig[k].Y = 0;
		//	k--;
		//}
		//ans = max(ans,0);
		cout << ans << endl;
	}

	return 0;
}
