#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
#define sqr(x) (x)*(x)

const int maxn = (int)1e6;
const int inf = (1 << 30) - 1;

LL n, t, was[maxn], p[maxn], q[maxn], rott[maxn];

struct circle
{
	LL x, y, r;
} a[maxn];

bool touch(int v, int u)
{
	return (sqr(a[v].x - a[u].x) + sqr(a[v].y - a[u].y) == sqr(a[v].r + a[u].r));
}

void dfs(int v, int c, LL P, LL Q)
{
	int g = __gcd(P, Q);
	Q /= g;
	P /= g;
	q[v] = Q;
	p[v] = P;

	was[v] = 1;
	rott[v] = c;
	for (int i = 1; i <= n; i++)
	{
		if (!was[i] && touch(v, i))
			dfs(i, c ^ 1, P * a[v].r, Q * a[i].r);
	}
}

int main()
{
	//freopen(fname"in", "r", stdin);
	//freopen(fname"out", "w", stdout);

	cin >> t;
	while (t--)
	{
		cin >> n;

		for (int i = 1; i <= n; i++)
		{
			cin >> a[i].x >> a[i].y >> a[i].r;
			was[i] = rott[i] = 0;
		}

	  	dfs(1, 0, 1, 1);
	
		for (int i = 1; i <= n; i++)
		{
			if (!was[i])
				cout << "not moving\n";
			else
			{
				if (q[i] == 1)
					cout << p[i] << " ";
				else
					cout << p[i] << "/" << q[i] << " ";
				if (rott[i] == 0)
					cout << "clockwise\n";
				else
					cout << "counterclockwise\n";
			}
		}
	}
	return 0;
}


