#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "d"

int x[1001];
int y[1001];
int r[1001];
bool used[1001];
bool cw[1001];
int n;

inline int sqr(int x)
{
	return x * x;
}

void dfs(int u, bool CW = true)
{
	used[u] = true;
	cw[u] = CW;
	for (int i = 0; i < n; ++i)
	{
		if (sqr(x[u] - x[i]) + sqr(y[u] - y[i]) != sqr(r[u] + r[i]))
			continue;
		if (used[i])
			continue;
		dfs(i, CW ^ 1);
	}
}

void solve()
{
	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
		scanf("%d%d%d", x + i, y + i, r + i);
	for (int i = 0; i < n; ++i)
		used[i] = false;
	dfs(0);
	for (int i = 0; i < n; ++i)
	{
		if (!used[i])
		{
			cout << "not moving\n";
			continue;
		}
		int p = r[0];
		int q = r[i];
		int g = __gcd(p, q);
		p /= g, q /= g;
		if (q > 1)
			cout << p << '/' << q << ' ';
		else
			cout << p << ' ';
		cout << (cw[i] ? "clockwise\n" : "counterclockwise\n");
	}
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
