#include <iostream>
#include <cstdio>
#include <string>
#include <vector>

using namespace std;

vector<int> solve(int n) {
    int cur_sum = 0;
    for (int len = 2; len < 50000; ++len) {
        if ((n * 2) % len != 0) continue;
        cur_sum = (n * 2) / len;
        cur_sum = cur_sum - len + 1;
        int a1 = cur_sum / 2;
        if (a1 <= 0) continue;
        vector<int> ans;
        int sum = 0;
        for (int i = a1; sum < n; ++i) {
            ans.push_back(i);
            sum += i;
        }
        if (sum != n) continue;
        return ans;
    }
    return vector<int> ();
}

int main()
{
    int tests;
    cin >> tests;
    while (tests--) {
        int n;
        cin >> n;
        vector<int> ans = solve(n);
        if (ans.size() == 0) {
            cout << "IMPOSSIBLE" << "\n";
        } else {
            cout << n << " =";
            for (int i = 0; i < ans.size(); ++i)
                cout << " " << ans[i] << (i != ans.size() - 1 ? " +" : "");
            cout << "\n";
        }
    }
    return 0;
}
