#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;

void solveOne() {
	ll k;
	cin >> k;
	ll s = 0, n = 0;
	for(ll i = 2; ; i++) {
		ll top = 2 * k - i * i + i;
		ll bottom = 2 * i;
		if(top <= 0) break;
		if(top % bottom == 0) {
			s = top / bottom;
			n = i;
			assert(s * n + n * (n - 1) / 2 == k);
			break;
		}
	}
	if(n == 0) cout << "IMPOSSIBLE" << "\n";
	else {
		cout << k << " = " << s;
		for(ll i = 1; i < n; i++) {
			cout << " + " << (s + i);
		}
		cout << "\n";
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	for(int i = 0; i < n; i++)
		solveOne();
	return 0;
}