#include <iostream>
#include <algorithm>
using namespace std;

const int kMaxN = 15e4;
const int kMaxK = 9;

pair<int, int> a[kMaxN];
int n, k;

int GetWithout(int pos)
{
    int i = 0;
    int val = 0;
    int tk = k;
    while (tk > 0) {
        if (i == pos) {
            ++i;
            continue;
        }
        val -= a[i].first;
        --tk;
        ++i;
    }
    return val;
}

int main()
{
    ios_base::sync_with_stdio(false);

    int tests;
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        cin >> n >> k;
        for (int i = 0; i < n; ++i) {
            cin >> a[i].second >> a[i].first;
        }

        if (n <= k) {
            cout << 0 << endl;
            continue;
        }

        sort(a, a + n);

        int ans = 0;

        for (int i = 0; i < n; ++i) {
            ans = max(ans, a[i].second - a[i].first + GetWithout(i));
        }

        cout << ans << endl;
    }

    return 0;
}
