#include<iostream>
#include<vector>
#include<stdio.h>
using namespace std;

const int MAX_N = 2000;
typedef long long lint;
lint gcd(lint a,lint b)
{
	return (a%b)?gcd(b%a,a):b;
}
vector<int> v[MAX_N];
int x[MAX_N],y[MAX_N],r[MAX_N];
pair<lint,lint> w[MAX_N];
int flag[MAX_N];

int sqr(int n)
{
	return n*n;
}

int length(int i,int j)
{
	return sqr(x[i]-x[j])+sqr(y[i]-y[j]);
}


bool check(int i,int j)
{
	int L = length(i,j);
	return (L==sqr(r[i]+r[j])); 
}



void dfs(int num,int color=0)
{
	if(flag[num]) return;
	flag[num]=color+1;
	lint p,q,d;
	for(int i=0;i<v[num].size();i++)
		if(!flag[v[num][i]])
		{
			p = w[num].first*r[num];
			q = w[num].second*r[v[num][i]];
			d= gcd(p,q);
			p/=d;	q/=d;
			w[v[num][i]]=pair<lint,lint>(p,q);
			dfs(v[num][i],(color+1)%2);
		}
}

void solve(int test)
{
	int N,i,j;
	scanf("%d",&N);
	for(i=0;i<N;i++)
	{
		scanf("%d%d%d",&x[i],&y[i],&r[i]);
		flag[i]=false;
		v[i].clear();
	}
	for(i=0;i<N;i++)
		for(j=i+1;j<N;j++)
			if(check(i,j))
			{
				v[i].push_back(j);
				v[j].push_back(i);
			}
	w[0]=pair<lint,lint>(1,1);
	dfs(0);
	for(i=0;i<N;i++)
	{
		if(!flag[i])
		{
			printf("not moving\n");
			continue;
		}
		if(w[i].second==1) printf("%lld ",w[i].first);
		else printf("%lld/%lld ",w[i].first,w[i].second);
		if(flag[i]==1) printf("clockwise\n");
		else printf("counterclockwise\n");
	}
}

int main()
{
	int i,tests;
	scanf("%d",&tests);
	for(i=1;i<=tests;i++) solve(i);
	return 0;
}