#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

int timerR = 0;

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	while(t--) {
		//++timerR;
	//cout << "Case #" << timerR << ": ";
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


int sqr(int a) {
	return a * a;
}

int gcd(int a, int b) {
	while(b) {
		a%=b;
		swap(a, b);
	}
	return a;
}

//#define int li
void solve() {
	int n;
	cin >> n;
	vi x(n), y(n), r(n);
	for(int i = 0; i < n; ++i) {
		cin >> x[i] >> y[i] >> r[i];
	}


	vector<int> d(n, -1);
	queue<int> q;
	q.push(0);
	d[0] = 0;
	while(!q.empty()) {
		int v = q.front();
		q.pop();
		for(int i = 0; i < n; ++i) {
			if(d[i] != -1)
				continue;
			if(sqr(x[i] - x[v]) + sqr(y[i] - y[v]) == sqr(r[i] + r[v])) {
				q.push(i);
				d[i] = d[v] + 1;
			}
		}
	}

	for(int i = 0; i < n; ++i) {
		if(d[i] == -1) {
			cout << "not moving\n";
			continue;
		}
		int g = gcd(r[0], r[i]);
		if(g != r[i])
			cout << r[0] / g << "/" << r[i] / g << " ";
		else
			cout << r[0] / g << " ";
		if(d[i] % 2)
			cout << "counter";
		cout << "clockwise\n";
	}
}