#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

int timerR = 0;

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	while(t--) {
		//++timerR;
	//cout << "Case #" << timerR << ": ";
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


#define int li

int gcd(int a, int b) {
	while(b) {
		a%=b;
		swap(a, b);
	}
	return a;
}


void solve() {
	int n;
	cin >> n;
	typedef pair<char, int> para;

	vector<para> v(n);


	int cnt[] = {0, 0};

	for(int i = 0; i < n; ++i) {
		cin >> v[i].second >> v[i].first;
		if(v[i].first == 'B') {
			cnt[0] += v[i].second;
		}
		else {
			cnt[1] += v[i].second;
		}
	}
	if(cnt[0] == 0 || cnt[1] == 0) {
		cout << cnt[0] + cnt[1] << "\n";
		return;
	}

	int g = gcd(cnt[0], cnt[1]);

	int otn[] = {cnt[0] / g, cnt[1] / g};


	int has[] = {0, 0};
	int ans = 0;
	for(int i = 0; i < n; ++i) {
		char need = 0;
		bool can = false;
		if(has[0] * otn[1]  == otn[0] * has[1]) {
			need = 'X';
		}
		else if( has[0] * otn[1]  < otn[0] * has[1]) {
			need = 'B';
			can = otn[0] * has[1] % otn[1] == 0;
		}
		else {
			need = 'W';
			can = otn[1] * has[0] % otn[0] == 0;
		}

		if(v[i].first == 'B') {
			has[0] += v[i].second;
		}
		else {
			has[1] += v[i].second;
		}

		char willneed = 0;
		if(has[0] * otn[1]  == otn[0] * has[1]) {
			willneed = 'X';
		}
		else if( has[0] * otn[1]  < otn[0] * has[1]) {
			willneed = 'B';
		}
		else {
			willneed = 'W';
		}


		if(can && need != willneed && need != 'X') {
			++ans;
		}
	}

	cout << ans << "\n";;
}