#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>


int n;
bool check(int cnt)
{
	int s = 1;
	int f = n / cnt;
	while(s < f)
	{
		int m = (s + f) / 2;
		i64 sum  = (i64)cnt * (i64)(m + m + cnt - 1) / 2;
		if (sum < n)
			s = m + 1;
		else f = m;
	}
	i64 sum = (i64)cnt * (i64)(s + s + cnt - 1) / 2;
	if (sum != n)
		return false;
	
	printf("%d = ", n);
	fore(j, s, s + cnt - 1)
	{
		printf("%d ", j);
		if (j != s + cnt - 1)
			printf("+ ");
	}
	printf("\n");
	return true;
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int tests;
	scanf("%d", &tests);
	forn(test, tests)
	{
		scanf("%d", &n);
		int limit = 2 * sqrt((double)n);
		bool found = false;
		for (int j = 2; j <= limit; j++)
		{
			if (check(j))
			{
				found = true;
				break;
			}
		}
		if (!found)
			printf("IMPOSSIBLE\n");
	}
}