#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define x first
#define y second
#define in(n) int (n) = nxt()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

int nxt() {
    int res;
    scanf("%d", &res);
    return res;
}


void solve(){
    in(t);
    while (t--) {
        in(n); in(k);
        int cost[n];
        int delta[n];
        int sz = 0;
        for (int i = 0; i < n; ++i) {
            in(v); in(c);
            if (v > c) {
                cost[sz] = c;
                delta[sz++] = v - c;
            }
        }

        n = sz;

        int id[n];

        for (int i = 0; i < n; ++i) {
            id[i] = i;
        }

        sort(id, id + n, [&](int a, int b) {
            return cost[a] + delta[a] < cost[b] + delta[b] || (cost[a] + delta[a] == cost[b] + delta[b] && cost[a] < cost[b]);
        });

        int l = 0, r = 1000000;
        while (l < r) {
            int mid = (l + r + 1) / 2;
            int dp[n + 1][k + 2];
            memset(dp, 0x3f, sizeof(dp));
            dp[0][0] = 0;
            for (int i = 0; i < n; ++i) {
                int cur = id[i];
                dp[i + 1][0] = dp[i][0];
                for (int j = 0; j <= k; ++j) {
                    dp[i + 1][j + 1] = dp[i][j + 1];
                    if (delta[cur] - dp[i][j] >= mid) {
                        dp[i + 1][j + 1] = min(dp[i + 1][j + 1], dp[i][j] + cost[cur]);
                    }
                }
            }
            if (dp[n][k + 1] != 0x3f3f3f3f) {
                l = mid;
            } else {
                r = mid - 1;
            }
        }
        cout << l << "\n";
    }

}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    solve();

    return 0;
}
