#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

typedef pa<ll, ll> pt;
#define x first
#define y second

pt operator - (const pt &a, const pt &b) {
	return pt(a.x - b.x, a.y - b.y);
}

ll operator ^ (const pt &a, const pt &b) {
	return a.x * b.y - a.y * b.x;
}

const int N = 100000;

struct Input {
	int n;
	pt a[N];
	
	bool read () {
		if (!(cin >> n)) {
			return 0;
		}
		forn (i, n) {
			int x, y;
			scanf("%d%d", &x, &y);
			a[i] = pt(x, y);
		}
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	int ans[N];
	
	void write () {
		forn (i, n - 1) {
			if (i) {
				printf(" ");
			}
			printf("%d", (ans[i] == n) ? 0 : ans[i]);
		}
		puts("");
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {
	
	bool check (const vi &v, const pt &p1, const pt &p2) {
		int l = 0, r = sz(v) - 1;
		auto f = [&] (int i) {return (p2 - p1) ^ (a[v[i]] - p1);};
		while (l < r) {
			int m1 = (l + r) >> 1;
			int m2 = m1 + 1;
			if (f(m1) > f(m2)) {
				r = m1;
			} else {
				l = m2;
			}
		}
		return f(l) > 0;
	}
	
	static const int M = 1 << 17;
	
	int m;
	
	vi t[2 * M];
	int lb[2 * M], rb[2 * M];
	
	int fnd (int l, int r, const pt &p1, const pt &p2, int v = 1) {
		if (lb[v] >= r || rb[v] <= l) {
			return n;
		}
		if (lb[v] >= l && rb[v] <= r) {
			if (!check(t[v], p1, p2)) {
				return n;
			}
		}
		if (v >= m) {
			return v - m;
		}
		int q = fnd(l, r, p1, p2, 2 * v);
		return (q < n) ? q : fnd(l, r, p1, p2, 2 * v + 1);
	}
	
	void solve () {
		m = 1;
		while (m < n) {
			m *= 2;
		}
		forn (i, m) {
			lb[i + m] = i;
			rb[i + m] = i + 1;
		}
		ford (i, m) {
			lb[i] = lb[2 * i];
			rb[i] = rb[2 * i + 1];
		}
		forn (i, 2 * m) {
			if (rb[i] > n) {
				continue;
			}
			for (int j = lb[i]; j < rb[i]; ++j) {
				while (sz(t[i]) > 1 && ((a[t[i][sz(t[i]) - 1]] - a[j]) ^ (a[t[i][sz(t[i]) - 2]] - a[j])) <= 0) {
					t[i].pop_back();
				}
				t[i].pb(j);
			}
		}
		forn (i, n - 1) {
			ans[i] = fnd(i + 2, n, a[i], a[i + 1]);
		}
	}
	
	void clear () {
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("b.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
#endif
	int t;
	cin >> t;
	forn (i, t) {
		sol.read();
		sol.solve();
		sol.write();
		sol.clear();
	}
	return 0;
}
