#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

set<int> lst;
int ans[222];

inline bool good(int x, int y) {
	if (!(x >= 0 && x < 4 && y >= 0 && y < 3)) {
		return false;
	}
	if (x == 3 && (y == 0 || y == 2)) {
		return false;
	}
	return true;
}

inline int val(int x, int y) {
	if (x == 3) {
		return 0;
	}
	return x * 3 + y + 1;
}

inline void gen(int x, int y, int z) {
	lst.insert(z);
	if (x >= 4) {
		return;
	}
	if (z * 10 + val(x, y) < 1000) {
		gen(x, y, z * 10 + val(x, y));
	}
	if (good(x, y + 1)) {
		gen(x, y + 1, z);
	}
	if (good(x + 1, y)) {
		gen(x + 1, y, z);
	}
}

inline void init() {
	for (int i = 0; i < 3; ++i) {
		for (int j = 0; j < 3; ++j) {
			if (good(i, j)) {
				gen(i, j, val(i, j));
			}
		}
	}
	for (int i = 1; i <= 200; ++i) {
		int best = -1;
		for (set<int>::iterator j = lst.begin(); j != lst.end(); ++j) {
			if (best == -1 || abs(*j - i) < abs(i - best)) {
				best = *j;
			}
		}
		ans[i] = best;
	}
}

int main() {
#ifdef LOCAL42
#define TASK "H"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	init();
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		int n;
		scanf("%d", &n);
		printf("%d\n", ans[n]);
	}
	return 0;
}
