#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

pii blocks[131072];

LL gcd(LL x, LL y) {
  while (y) {
    LL t = x;
    x = y;
    y = t % y;
  }
  return x;
}

void test() {
  int n;
  scanf("%d", &n);
  char str[8];
  LL cnt[2] = {0, 0};
  FOR(i, 0, n) scanf("%d%s", &blocks[i].first, str), blocks[i].second = (str[0] == 'W'), cnt[blocks[i].second] += blocks[i].first;
  if (cnt[0] == 0 || cnt[1] == 0) {
    printf("%d\n", cnt[0] + cnt[1]);
    return;
  }
  int answer = 0;
  LL g = gcd(cnt[0], cnt[1]);
  cnt[0] /= g; cnt[1] /= g;
  LL curr[2] = {0, 0};
  FOR(i, 0, n) {
    int c = blocks[i].second;
    int o = 1 - c;
    if (curr[o] && !(curr[o] % cnt[o]) && curr[c] + blocks[i].first >= cnt[c] * (curr[o] / cnt[o]) && curr[c] <= cnt[c] * (curr[o] / cnt[o])) {
      answer += 1;
      curr[c] = curr[c] + blocks[i].first - cnt[c] * (curr[o] / cnt[o]);
      curr[o] = 0;
    } else {
      curr[c] += blocks[i].first;
    }
  }
  printf("%d\n", answer);
}

int main() {
  int T;
  scanf("%d", &T);
  FOR(i, 0, T) test();
  return 0;
}
