#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

vector<int> Times;

pair<pii, int> aliens[1024];
int dp[1024][1024];

void test() {
  Times.clear();
  int n;
  scanf("%d", &n);
  FOR(i, 0, n) {
    scanf("%d%d%d", &aliens[i].first.first, &aliens[i].first.second, &aliens[i].second);
    Times.push_back(aliens[i].first.first);
    Times.push_back(aliens[i].first.second);
  }
  sort(Times.begin(), Times.end());
  Times.resize(unique(Times.begin(), Times.end()) - Times.begin());
  FOR(i, 0, n) {
    aliens[i].first.first = lower_bound(Times.begin(), Times.end(), aliens[i].first.first) - Times.begin();
    aliens[i].first.second = lower_bound(Times.begin(), Times.end(), aliens[i].first.second) - Times.begin();
  }
  memset(dp, 0, sizeof dp);
  FOR(len, 1, Times.size() + 1) FOR(L, 0, Times.size() - len + 1) {
    int R = L + len - 1;
    int high = -1;
    FOR(i, 0, n) {
      if (aliens[i].first.first >= L && aliens[i].first.second <= R && (high < 0 || aliens[i].second > aliens[high].second)) {
        high = i;
      }
    }
    if (high < 0) continue;
    dp[L][R] = 1000000000;
    FOR(i, 0, n) {
      if (aliens[i].first.first >= L && aliens[i].first.second >= aliens[high].first.first && aliens[i].first.second <= aliens[high].first.second) {
        dp[L][R] = min(dp[L][R], aliens[high].second + (aliens[i].first.second ? dp[L][aliens[i].first.second - 1] : 0) + dp[aliens[i].first.second + 1][R]);
      }
    }
  }
  printf("%d\n", dp[0][Times.size() - 1]);
}

int main() {
  int T;
  scanf("%d", &T);
  FOR(i, 0, T) test();
  return 0;
}

