#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
#include <bitset>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 2000*100 + 10;
const dbl eps = 1e-7;
const int mod = 1e9 + 7;

ll gcd (ll a, ll b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	int t;
	scanf("%d", &t);
	while (t--) {		
		int n;
		scanf("%d", &n);
		ll w = 0, b = 0;

		vector <pair <ll, char> > input (n);
		for (int i = 0; i < n; i++) {
			ll cnt;
			char c;
			scanf("%lld %c\n", &cnt, &c);
			input[i] = mp(cnt, c);
			if (c == 'W')
				w += cnt;
			else
				b += cnt;
		}
		ll d = gcd(w, b);
		pair <ll, ll> rall = mp (w / d, b / d);
		if ((w == 0) || (b == 0)) {
			printf("%lld\n", w + b);
			continue;
		}
		w = b = 0;
		ll ans = 0;
		for (int i = 0; i < n; i++) {
			pair <ll, char> cur = input[i];
			if (cur.Y == 'W') {
				if (b == 0) {
					w += cur.X;
					continue;
				}
				if (	( (double)w/(double)b < (double)rall.X/(double)rall.Y ) && ( (double)rall.X/(double)rall.Y <= (double)(w + cur.X)/(double)b )	) {
					if ((b % rall.Y) == 0) {
						ans++;
						w = cur.X - (b/rall.Y)*rall.X;
						b = 0;
					}
					else
					w += cur.X;
				}
				else
					w += cur.X;
			}
			else {
				if (w == 0) {
					b += cur.X;
					continue;
				}
				if (	( (double)b/(double)w < (double)rall.Y/(double)rall.X ) && ( (double)rall.Y/(double)rall.X <= (double)(b + cur.X)/(double)w )	) {
					if ((w % rall.X) == 0) {
						ans++;
						b = cur.X - rall.Y*(w/rall.X);
						w = 0;
					}
					else
						b += cur.X;
				}
				else
					b += cur.X;
			}
		}
		printf("%lld\n", ans);
	}
	return 0;
}