#include <algorithm>
#include <queue>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

int nums[4][3] = {
    {1,2,3},
    {4,5,6},
    {7,8,9},
    {-1, 0, -1}
};

ii loc[10];

//set<int> poss;
string s;

bool visited[5][5][3][4000];
//void dfs(int x, int y, int dir, int num) {
/*
bool match(int x, int y, int dir, int at) {
    //poss.insert(num);

    //printf("%d %d %d %d\n", x, y, dir, num);

    if (visited[x][y][dir == -1 ? 0 : 1][num])
        return false;
    visited[x][y][dir == -1 ? 0 : 1][num] = true;

    if (at == size(s)) {
        return true;
    }
    if (x == 5) {
        return false;
    }

    while (at < size(s) && nums[x][y] == s[at] - '0') {
        at++;
    }

    dfs(x+1, y, -1, at);
    dfs(x+1, y, 1, at);
    if (y + dir >= 0 && y + dir < 3) {
        dfs(x, y+dir, dir, at);
    }
}
*/

bool possible(int n) {
    if (n == 0) 
        return true;

    //printf("trying %d\n", n);

    vector<int> arr;
    while (n) {
        arr.push_back(n % 10);
        n /= 10;
    }

    int x = -1;
    int y = 0;
    int dy = 0;

    for (int i = size(arr) - 1; i >= 0; i--) {
        int now = arr[i];
        ii l = loc[now];
        if (l.first < x) 
            return false;
        if (l.second < y) 
            return false;

        if (l.first == x) {

            int d = l.second - y;
            if (d < 0) {
                d = -1;
            } else if (d > 0) {
                d = 1;
            }

            if (d < 0) {
                return false;
            }

            if (d != 0 && dy != 0 && d != dy) {
                return false;
            }

            if (d != 0) {
                dy = d;
            }

            x = l.first;
            y = l.second;

        } else {
            //printf("%d\n", l.first > x ? 1337 : -1337);
            assert(l.first > x);
            x = l.first;
            y = l.second;
            dy = 0;
        }
    }

    return true;
}

int main() {
    /*
    memset(visited, 0, sizeof(visited));

    for (int x = 0; x < 4; x++) {
        for (int y = 0; y < 3; y++) {
            dfs(x, y, 0, 1);
            dfs(x, y, 0, -1);
        }
    }

    vi arr(poss.begin(), poss.end());
    */

    for (int i = 0; i < 4; i++) {
        for (int j = 0; j < 3; j++) {
            if (nums[i][j] != -1) {
                loc[nums[i][j]] = ii(i, j);
            }
        }
    }

    int ts;
    scanf("%d\n", &ts);
    for (int t = 0; t < ts; t++) {
        int x;
        scanf("%d\n", &x);
        queue<ii> Q;
        Q.push(ii(x, 1));
        Q.push(ii(x-1, -1));
        while (!Q.empty()) {
            ii cur = Q.front(); 
            Q.pop();
            if (cur.first < 0) {
                continue;
            }

            if (possible(cur.first)) {
                printf("%d\n", cur.first);
                break;
            }

            Q.push(ii(cur.first + cur.second, cur.second));
        }
    }

    return 0;
}
