#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

int k;

bool read() {
	return (cin >> k);
}

set<int> s;

void solve() {
	set<int>::iterator it = s.lower_bound(k);
	set<int>::iterator it1 = it;
	if (it != s.begin())
		it--;
	if (abs(*it - k) < abs(*it1 - k))
		cout << *it << endl;
	else
		cout << *it1 << endl;
}

int num[4][3] = 
{
	{1, 2, 3}, 
	{4, 5, 6},
	{7, 8, 9},
	{-1, 0, -1}
};

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	int t;
	cin >> t;

	queue<pair<pt, int> > q;
	q.push(mp(mp(0, 0), 0));

	while(!q.empty())
	{
		pt v = q.front().first;
		int x = q.front().sc;
		q.pop();
		s.insert(x);
		if (x > 200)
			continue;
		if (num[v.ft][v.sc] == -1)
			continue;
		int nx = x * 10 + num[v.ft][v.sc];
		if (nx != x)
			q.push(mp(v, nx));

		if (v.sc < 2)
			q.push(mp(mp(v.ft, v.sc + 1), x));
		if (v.ft < 3)
			q.push(mp(mp(v.ft + 1, v.sc), x));
	}

	while (read())
		solve();

	return 0;
}