#include <iostream>
#include <sstream>
#include <vector>

using namespace std;

typedef long long int Z;

char ch[100005];
Z len[100005];

int main() {
	cin.sync_with_stdio(false);
	
	int Te;
	cin >> Te;
	
	for(int te = 0; te < Te; ++te) {
		Z n;
		cin >> n;
		
		Z bs = 0;
		Z ws = 0;
		for(Z i = 0; i < n; ++i) {
			cin >> len[i] >> ch[i];
			
			if(ch[i] == 'B') {
				bs += len[i];
			} else {
				ws += len[i];
			}
		}
		
		if(bs == 0) {
			cout << ws << "\n";
		} else if(ws == 0) {
			cout << bs << "\n";
		} else {
			Z bseen = 0;
			Z wseen = 0;
			
			Z blocks = 0;
			for(Z i = 0; i < n; ++i) {
				if(ch[i] == 'W') {
					swap(bs, ws);
					swap(bseen, wseen);
				}
					if(wseen != 0 && bs * wseen % ws == 0) {
						Z target = bs * wseen / ws;
						if(target >= bseen && target <= bseen + len[i]) {
							++blocks;
							wseen = 0;
							bseen = bseen + len[i] - target;
						} else {
							bseen += len[i];
						}
					} else {
						bseen += len[i];
					}
				if(ch[i] == 'W') {
					swap(bs, ws);
					swap(bseen, wseen);
				}
			}
			cout << blocks << "\n";
		}
	}
	
	return 0;
}
