#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

using namespace std;

const int N = 1111111;
const int BASE = 1000000009;

char a[N], b[N], c[N];
int f[2][2], ff[2][2], tt;
int cost[30][30][30][2][2][2][2];

int main() {
	freopen("input.txt", "r", stdin);
	for (int x = 0; x <= 27; x++) {
		for (int y = 0; y <= 27; y++) {
			for (int z = 0; z <= 27; z++) {
				for (int i = 0; i <= 1; i++) {
					for (int j = 0; j <= 1; j++) {
						int sx, sy, sz, ex, ey, ez;
						if (x == 27) {
							sx = 1; ex = 26;
						} else {
							sx = x; ex = x;
						}
						if (y == 27) {
							sy = 1; ey = 26;
						} else {
							sy = y; ey = y;
						}
						if (z == 27) {
							sz = 1; ez = 26;
						} else {
							sz = z; ez = z;
						}
						for (int xx = sx; xx <= ex; xx++) {
							for (int yy = sy; yy <= ey; yy++) {
								for (int zz = sz; zz <= ez; zz++) {
									int ni = i, nj = j;
									if ((i == 0) && (xx > yy)) continue;
									if ((j == 0) && (yy > zz)) continue;
									if (xx < yy) ni = 1;
									if (yy < zz) nj = 1;
									cost[x][y][z][i][j][ni][nj]++;
								}
							}
						}
					}
				}
			}
		}
	}
	scanf("%d\n", &tt);
	while (tt--) {
		int na, nb, nc;
		gets(a); na = strlen(a);
		gets(b); nb = strlen(b);
		gets(c); nc = strlen(c);
		int n = max(na, max(nb, nc));
		memset(f, 0, sizeof(f));
		f[0][0] = 1;
		for (int i = 0; i < n; i++) {
			int ea, eb, ec;
			if (i >= na) ea = 0; else
			if (a[i] == '?') ea = 27; else
			ea = a[i] - 'a' + 1;
			if (i >= nb) eb = 0; else
			if (b[i] == '?') eb = 27; else
			eb = b[i] - 'a' + 1;
			if (i >= nc) ec = 0; else
			if (c[i] == '?') ec = 27; else
			ec = c[i] - 'a' + 1;
			memset(ff, 0, sizeof(ff));
			for (int x = 0; x < 2; x++) {
				for (int y = 0; y < 2; y++) {
					for (int xx = 0; xx < 2; xx++) {
						for (int yy = 0; yy < 2; yy++) {
							int cur = (f[x][y] * 1LL * cost[ea][eb][ec][x][y][xx][yy]) % BASE;
							ff[xx][yy] += cur;
							if (ff[xx][yy] >= BASE) ff[xx][yy] -= BASE;
						}
					}
				}
			}
			for (int x = 0; x < 2; x++) for (int y = 0; y < 2; y++) f[x][y] = ff[x][y];
		}
		printf("%d\n", f[1][1]);
	}
}