#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <queue>

typedef long long ll;
typedef long double ld;

using namespace std;

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	cin.sync_with_stdio(false);

	int t;
	cin >> t;

	for (int i = 0; i < t; i++)
	{
		ll N;
		cin >> N;

		ll goodA;
		ll goodD = -1;
		for (ll d = 2; d <= 100000; d++)
		{
			ll top = (2 * N + d - d*d);
			ll bottom = (2 * d);

			if (top < bottom)
				break;

			if ((top) % (bottom) == 0)
			{
				goodA = top/bottom;
				goodD = d;
				break;
			}
		}

		if (goodD != -1)
		{
			cout << N << " = ";
			for (ll i = 0; i < goodD-1; i++)
				cout << goodA + i << " + ";
			cout << goodA + goodD - 1 << endl;
		}
		else
			cout << "IMPOSSIBLE" << endl;
	}
				

	return 0;
}