#include<cstdlib>

#include<iostream>
#include<fstream>
#include<sstream>

#include<vector>
#include<string>
#include<set>
#include<map>

#include<cmath>
#include<algorithm>
#include<limits>
#include<queue>

using namespace std;

#define fi(i, a, b) for (int i = a; i < b; i++)
#define lol long long

vector<int> prost;

void buildProst(int n)
{
	prost.push_back(2);
	fi(i, 3, n)
	{
		bool isprost = true;
		for (int j = 2; j <= ceil(sqrt((double)i)); j++)
		{
			if (i % j == 0)
			{
				isprost = false;
				break;
			}
		}
		if (isprost)
			prost.push_back(i);
	}
}

class Drob
{
private:
	map<int, int> c, z;
public:
	Drob(){}
	Drob(int c_, int z_)
	{
		fi(i, 0, prost.size())
		{
			while (c_ % prost[i] ==0)
			{
				c_ /= prost[i];
				c[prost[i]]++;
			}
			while (z_ % prost[i] ==0)
			{
				z_ /= prost[i];
				z[prost[i]]++;
			}
			if (c_ == 1 && z_ == 1)
				break;
		}

		for (map<int, int>::iterator it = c.begin(); it != c.end(); it++)
		{
			int m = min(it->second, z[it->first]);
			it->second -= m;
			z[it->first] -= m;
		}
	}

	int ches()
	{
		int res = 1;
		for (map<int, int>::iterator it = c.begin(); it != c.end(); it++)
		{
			fi(i, 0, it->second)
				res *= it->first;
		}
		return res;
	}	
	
	int znam()
	{
		int res = 1;
		for (map<int, int>::iterator it = z.begin(); it != z.end(); it++)
		{
			fi(i, 0, it->second)
				res *= it->first;
		}
		return res;
	}
};

struct Whell
{
	Whell(int x, int y, int r) : x(x), y(y), r(r) {direction = 0; visited = false;}
	int x, y, r, direction;
	Drob speed;
	bool visited;
};

vector<Whell> whells;

int main()
{
#if defined (DEBUG) || defined (_DEBUG)
	ifstream cin("input.txt");
	ofstream cout("output.txt");
#endif

	buildProst(100000);

	int t;
	cin >> t;

	fi(z, 0, t)
	{
		int n;
		cin >> n;

		fi(i, 0, n)
		{
			int x, y, r;
			cin >> x >> y >> r;
			whells.push_back(Whell(x, y, r));
		}

		whells[0].direction = 1;
		whells[0].speed = Drob(1, 1);
	}

	queue<Whell*> q;
	q.push(&whells[0]);

	while (q.size() != 0)
	{
		fi(i, 0, whells.size())
		{
			if (!whells[i].visited)
			if (pow(q.front()->x - whells[i].x, 2.0) + pow(q.front()->y - whells[i].y, 2.0) == pow(q.front()->r + whells[i].r, 2.0))
			{
				whells[i].direction = q.front()->direction * -1;
//				whells[i].speed = Drob(q.front()->speed.ches() * whells[i].r, q.front()->speed.znam() * q.front()->r);
				whells[i].speed = Drob(q.front()->speed.ches() * q.front()->r, q.front()->speed.znam() * whells[i].r);
				whells[i].visited = true;
				q.push(&whells[i]);
			}
		}
		q.pop();
	}

	//fi(i, 0, whells.size())
	//{
	//	fi(j, 0, whells.size())
	//	{
	//		if (whells[i].direction == 0)
	//	}
	//}

	fi(i, 0, whells.size())
	{
		if (whells[i].direction == 1)
		{
			if (whells[i].speed.znam() == 1)
				cout << whells[i].speed.ches() << ' ' << "clockwise" << endl;
			else
				cout << whells[i].speed.ches() << '/' << whells[i].speed.znam() << ' ' << "clockwise" << endl;
		}
		if (whells[i].direction == -1)
		{
			if (whells[i].speed.znam() == 1)
				cout << whells[i].speed.ches() << ' ' << "counterclockwise" << endl;
			else
				cout << whells[i].speed.ches() << '/' << whells[i].speed.znam() << ' ' << "counterclockwise" << endl;
		}
		if (whells[i].direction == 0)
		{
			cout << "not moving" << endl;
		}
	}

	return 0;
}